unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, ComCtrls;
type

  // ۩w Header
  // RO (ɮסBǦr...)
  // Ѽ (ɦWBr...)
  TDCHeader = record
    Command: string[20];
    Param: string[255];
  end;

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    rbtnFile: TRadioButton;
    rbtnSQL: TRadioButton;
    rbtnAuth: TRadioButton;
    Label1: TLabel;
    edtParam: TEdit;
    btnBrowse: TButton;
    Label2: TLabel;
    edtHost: TEdit;
    Label3: TLabel;
    edtPort: TEdit;
    btnGo: TButton;
    HttpC: TIdHTTP;
    odlg1: TOpenDialog;
    ProgressBar1: TProgressBar;
    Label4: TLabel;
    lblDisp: TLabel;
    Label5: TLabel;
    edtPath: TEdit;
    procedure OnCommandClick(Sender: TObject);
    procedure btnBrowseClick(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
    procedure HttpCWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure HttpCWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure HttpCWork(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// U RadioButton ..
procedure TForm1.OnCommandClick(Sender: TObject);
begin
  // uܶɮ׮ɡA"Browse" ~| Enable
  if rbtnFile.Checked then
    btnBrowse.Enabled := True
  else
    btnBrowse.Enabled := False;
end;

// U Browse ɡA|} OpenDialog ܭn Upload ɮ
procedure TForm1.btnBrowseClick(Sender: TObject);
begin
  if odlg1.Execute then begin
    edtParam.Text := odlg1.FileName;
  end;
end;

{
 U GO!
 ھڿܪROMѼƶǻ
 Command: Send File (ɮ)
 Param  : nWɮɦW (t|)

 Command: Send String (Ǧr)
 Param  : nWǪr

 Command: Get File (q Server ɮצ^)
 Param  : ^ɮתɦW (|wb File Save Path)
}
procedure TForm1.btnGoClick(Sender: TObject);
var
  // ۩w Header
  DCHead: TDCHeader;
  // ۩w Header Struct jp
  RecordSize: Integer;
  // WǪ Buffer
  Buffer: TMemoryStream;
  // pn upload file, NΦܼƸJɮ
  AFile: TFileStream;
  // Ȧs
  tmpS: String;
  //  Server ^ɮ or r
  ret: TStream;
begin
  // J۩w Command ۩w Struct
  // o̪OݩM Server ݤ@P
  if rbtnFile.Checked then
    // ǰeɮ
    DCHead.Command := 'SSFILE'
  else if rbtnSQL.Checked then
    // ǰer
    DCHead.Command := 'SSTR'
  else if rbtnAuth.Checked then
    // ɮ
    DCHead.Command := 'SGFILE';
  if DCHead.Command <> 'SSTR' then
    DCHead.Param := ExtractFileName(edtParam.Text)
  else
    DCHead.Param := edtParam.Text;

  tmpS := edtParam.Text;

  // O ۩w struct jp
  RecordSize := SizeOf(DCHead);
  // Create Buffer
  Buffer := TMemoryStream.Create;
  try
    // gJ۩w struct jp
    Buffer.Write(RecordSize, SizeOf(Buffer));
    // gJ۩w struct
    Buffer.Write(DCHead, RecordSize);

    // ̤PRO@P
    // pGnǰeɮ׮
    if DCHead.Command = 'SSFILE' then begin
      // ŪJnǰeɮ
      AFile := TFileStream.Create(tmpS, fmOpenRead);
      try
        // ӽƻs Buffer h
        Buffer.CopyFrom(AFile, 0);
      finally
        AFile.Free;
      end;
    end;
    // ]w Server  HostBPort
    HttpC.Host := edtHost.Text;
    HttpC.Port := StrToInt(edtPort.Text);
    // N Buffer mm}YAǳƶǰe
    Buffer.Position := 0;

    // pGnɮתܡAhݥ Create n
    // pGܡAw nil Yi
    if DCHead.Command = 'SGFILE' then
      ret := TFileStream.Create(edtPath.Text + DCHead.Param, fmCreate)
    else
      ret := TStringStream.Create('');
    try
      try
        // Ĥ@ӰѼƭ쥻ݫwɦWAڭ̤ݭn..
        // GiHHKw
        // ĤGӰѼƬOڭ̭몺 BufferA۩wHeaderData
        // ĤTӰѼƬO^ǭȡA Stream A
        HttpC.Post('SuperBeckzs', Buffer, ret);
        // pG Server ǧ 200Ahܦ\
        // o 200 Oڦb Server w.. iH
        if HttpC.ResponseCode = 200 then
          ShowMessage('Success Send Command.')
        else
          ShowMessage('Send Command Failed.');

        if ret is TStringStream then
          ShowMessage(Format('^ǭȡG%s', [TStringStream(ret).DataString]));
      except
        on E: Exception do
          ShowMessage(E.Message);
      end;
    finally
      ret.Free;
    end;
  finally
    Buffer.Free;
  end;
end;

// }lǰe
// Ψ initial Progress Bar
// AWorkCountMax: ǰe Bytes 
// AWorkMode: ǰeҦ wmRead Ū wmWrite gJ
procedure TForm1.HttpCWorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  ProgressBar1.Position := 0;
  ProgressBar1.Max := AWorkCountMax;
  if AWorkMode = wmWrite then
    lblDisp.Caption := 'Start Transfer'
  else
    lblDisp.Caption := 'Start Receive';
end;

// ǰe
procedure TForm1.HttpCWorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
  ProgressBar1.Position := 0;
  if AWorkMode = wmWrite then
    lblDisp.Caption := 'Trasfer complete!'
  else
  lblDisp.Caption := 'Receive complete!';
end;

// ǰe
// AWorkCount: ثewǰeh Bytes
procedure TForm1.HttpCWork(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
  ProgressBar1.Position := AWorkCount;
  if AWorkMode = wmWrite then
    lblDisp.Caption := Format('Transfering. %d/%d', [AWorkCount, ProgressBar1.Max])
  else
    lblDisp.Caption := Format('Receiving. %d/%d', [AWorkCount, ProgressBar1.Max]);
  Application.ProcessMessages;
end;

end.
